/******************************************************************************/
/*  ktguard                  Object REXX Samples                              */
/*                                                                            */
/*                                                                            */
/*  Licensed Materials - Property of IBM                                      */
/*  IBM Object REXX for AIX                                                   */
/*  (C) Copyright IBM Corp. 1998,  2004                                       */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/* DISCLAIMER OF WARRANTIES.  The following [enclosed]                        */
/* code is sample code created by IBM Corporation. This                       */
/* sample code is not part of any standard or IBM                             */
/* product and is provided to you solely for the                              */
/* purpose of assisting you in the development of your                        */
/* applications.  The code is provided "AS IS", without                       */
/* warranty of any kind.  IBM shall not be liable for                         */
/* any damages arising out of your use of the sample                          */
/* code,  even if they have been advised of the                               */
/* possibility of such damages.                                               */
/* -------------------------------------------------------------------------- */
/*                                                                            */
/*  Description:                                                              */
/*  A guard instruction example.                                              */
/*                                                                            */
/*  This program demonstrates the use of the start method and the guard       */
/*  instruction to control execution of several programs.  In this sample,    */
/*  the programs are controlled by one 'guarded' variable.                    */
/******************************************************************************/

/* Define sample class and add methods we will use */
sample = .object~subclass('Sample')
m1 = 'expose g; guard off when g; use arg text; say text'
sample~define('WAIT_ON',  m1)
m2 = 'expose g; use arg g'
sample~define('SETGUARD', m2)

/* Start up 10 invocations of WAIT_ON */
a = sample~new~~setguard(0)                 /* g is false so programs will    */
                                            /* wait on guard instruction      */
do i = 1 to 10
  say 'Start invocation' right(i,2) '(and wait)'
  a~start('WAIT_ON', '  Invocation' right(i,2) 'completing')
end

/* Now let them all run */
say 'Press enter to set guard expression true...'
parse pull .
a~setguard(1)                               /* Setting g to 1 allows programs */
                                            /* to run.                        */
